    type token =
        Id of Strng.t
      | Key of Strng.t
      | LP
      | RP
      | Dot
      | Lam
    module Lexer :
      sig
        val keywords : char list Lst.t
        val is_key : char list -> bool
        val idorkey : (token, char) Parser.t
        val lpar : (token, char) Parser.t
        val rpar : (token, char) Parser.t
        val dot : (token, char) Parser.t
        val lam : (token, char) Parser.t
        val lex : ('a, char) Parser.t -> ('a, char) Parser.t
        val token : (token, char) Parser.t
        val tokenize : (token list, char) Parser.t
      end
    type t =
        Var of Strng.t
      | Con of Strng.t
      | App of (t * t)
      | Abs of (Strng.t * t)
      | Let of (Strng.t * t * t)
      | Ite of (t * t * t)
    val primitives : char list Lst.t
    val is_prim : char list -> bool
    module Parser :
      sig
        val key : string -> (Strng.t, token) Parser.t
        val var : (Strng.t, token) Parser.t
        val con : (Strng.t, token) Parser.t
        val lpar : (unit, token) Parser.t
        val rpar : (unit, token) Parser.t
        val dot : (unit, token) Parser.t
        val lam : (unit, token) Parser.t
        val mk_abs : t -> Strng.t list -> t
        val e : unit -> (t, token) Parser.t
        val f : t -> (t, token) Parser.t
        val ite : unit -> (t, token) Parser.t
        val letin : unit -> (t, token) Parser.t
        val abs : unit -> (t, token) Parser.t
        val g : unit -> (t, token) Parser.t
        val expression : (t, token) Parser.t
      end
    val of_string : string -> t
    val toplevel_printer : Format.formatter -> t -> unit
    val print_abs : Format.formatter -> t -> unit
